﻿namespace SpikingNeuronNetwork.Lib.Interfaces
{
    using System.Collections.Generic;

    /// <summary>
    /// Error Derivative Parameters Interface
    /// </summary>
    public interface IErrorDerivativeParameters
    {
        /// <summary>
        /// Gets a list of the synapses for which there are error derivative parameters
        /// </summary>
        /// <returns>The list of the synapses for which there are error derivative parameters</returns>
        List<Synapse> GetSynapses();

        /// <summary>
        /// Get the derivate of the error relative change in weight for a certain synapse
        /// </summary>
        /// <param name="synapse">The synapse</param>
        /// <returns>The error derivative</returns>
        double GetErrorDerivative(Synapse synapse);
    }
}
