﻿namespace SpikingNeuronNetwork.Lib.Interfaces
{
    using Training;

    /// <summary>
    /// Training Algorithm Interface
    /// </summary>
    public interface ITrainingAlgorithm
    {
        /// <summary>
        /// Update the weights in the current network according to the training algorithm
        /// </summary>
        /// <param name="trainingStats">The training statistic parameters</param>
        /// <param name="errorDerivativeParameters">The current error derivative parameters</param>
        /// <param name="previousErrorDerivativeParameters">The previous error derivative parameters</param>
        void UpdateWeights(TrainingStats trainingStats, IErrorDerivativeParameters errorDerivativeParameters, IErrorDerivativeParameters previousErrorDerivativeParameters);
    }
}
