﻿namespace SpikingNeuronNetwork.Lib.NeuronModels
{
    using Interfaces;
    using System;
    using System.Collections.Generic;
    using Training;
    
    /// <summary>
    /// Quadratic Integrate and Fire Spiking Neuron Class
    /// </summary>
    public class QifNeuron : SpikingNeuron
    {        
        /// <summary>
        /// The state to which a neuron returns to after spiking
        /// </summary>
        public override double PostSpikeState
        {
            get { throw new NotImplementedException(); }
        }

        /// <summary>
        /// The initial state of the neuron
        /// </summary>
        public override double InitialState
        {
            get { throw new NotImplementedException(); }
        }

        /// <summary>
        /// The remaining time until the neuron spikes absent further input spikes
        /// </summary>
        public override double RemainingTimeToSpike
        {
            get { throw new NotImplementedException(); }
        }

        /// <summary>
        /// Clones a neuron by removing network association
        /// </summary>
        /// <returns>A stand alone neuron</returns>
        public override ISpikingNeuron Clone()
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Runs the theta neuron, advancing the state and producing up to maxNumOutputSpikes 
        /// output spikes in response to inputSpikes
        /// </summary>
        /// <param name="inputSpikes">The input spikes</param>
        /// <param name="maxNumOutputSpikes">The maximum number of output spikes to be produced</param>
        /// <returns>The output spikes</returns>
        public override List<Spike> RunThetaNeuron(List<Spike> inputSpikes, int maxNumOutputSpikes = MaxNumOutputSpikes)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Updates the neuron's state variable, given a spike is currently being received on a synapse with weight
        /// </summary>
        /// <param name="weight">The synaptic weight</param>
        /// <returns>A collection of output spikes</returns>
        public override IEnumerable<Spike> UpdateStateVariableOnSpike(double weight)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Advances the neuron's state to newTime
        /// </summary>
        /// <param name="newTime">The new neuron time</param>
        /// <returns>A collection of output spikes</returns>
        public override IEnumerable<Spike> AdvanceNeuronState(double newTime)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Calculates Post Spike Derivatives, that is the derivate of the state after the current input spike
        /// relative to the derivative of the state after the previous input spike
        /// </summary>
        /// <param name="neuronFiringHistory">The neuron firing history, includes a summary of states before and after all input spikes</param>
        /// <returns>A list of post spike derivatives</returns>
        public override List<double> CalculatePostSpikeDerivatives(NeuronFiringHistory neuronFiringHistory)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Calculates Output Spike Derivatives, that is the derivate of the output spike time relative to both the
        /// weight on each synapse and the input spike time on each synapse
        /// </summary>
        /// <param name="neuronFiringHistory">The neuron firing history, includes a summary of states before and after all input spikes</param>
        /// <returns>A list of output spike time derivatives</returns>
        public override Dictionary<Synapse, NeuronDerivativeParameters> CalculateOutputSpikeTimeDerivatives(NeuronFiringHistory neuronFiringHistory)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Calculate the state derivative as a function of the state variable
        /// </summary>
        /// <param name="stateVariable">The state variable</param>
        /// <returns>The state derivative</returns>
        public override double StateDerivative(double stateVariable)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Maximum number of numerical integration iterations
        /// </summary>
        public override double MaxNumericalIntegrationIterations
        {
            get { throw new NotImplementedException(); }
        }

        /// <summary>
        /// Operating region
        /// </summary>
        public override OperatingRegion OperatingRegion
        {
            get { throw new NotImplementedException(); }
        }

        /// <summary>
        /// The spike threshold, the state at which an output spike is produced
        /// </summary>
        public override double SpikeThreshold
        {
            get { throw new NotImplementedException(); }
        }
    }
}
