﻿namespace SpikingNeuronNetwork.Lib
{
    /// <summary>
    /// Spike Class
    /// </summary>
    public class Spike
    {
        /// <summary>
        /// Gets or sets the identifier.
        /// </summary>
        /// <value>
        /// The identifier.
        /// </value>
        public int Id { get; set; }

        /// <summary>
        /// Gets or sets the index of the neuron.
        /// </summary>
        /// <value>
        /// The index of the neuron.
        /// </value>
        public int NeuronIndex { get; set; }

        /// <summary>
        /// Gets or sets the time.
        /// </summary>
        /// <value>
        /// The time.
        /// </value>
        public double Time { get; set; }

        /// <summary>
        /// Returns a <see cref="System.String" /> that represents this instance.
        /// </summary>
        /// <returns>
        /// A <see cref="System.String" /> that represents this instance.
        /// </returns>
        public override string ToString()
        {
            return "Spike from index " + NeuronIndex + " at time " + Time + "\n";
        }
    }
}
